#include <dos.h>
#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>
#include "midi.h"
#include "modex.h"
#include "keyboard.h"

#include "classes.h"

extern unsigned char far *sprites;
extern unsigned char far *msprites;
CObject extern *first;

const byte dsprites[19]={27,27,28,28,52,52,53,53,82,82};

CDrop::CDrop(int nx, int ny,int nd, unsigned sdelay)
{
 score=100;
 status=0;
 //lifetime=0;
 identity=5;
 x=nx*3; y=ny; dir=nd;
 stimer=sdelay;
 timer=0; fall=0;
 anim=27;
}

void CDrop::Draw(int page)
{
 if (!stimer)
 {
  if (!dir)
  {
   putxsprite(x/3,y,page,sprites+514*anim);
  }
  else
  {
   putxsprite(x/3,y,page,msprites+514*anim);
  }
 }
}

void CDrop::Move()
{
 if (stimer)
 {
  stimer--;
  if (!stimer)
   status=1;
  return;
 }

 /************************* Wasser bewegt sich vorwrts *******************/

 if (status==1)
 {
  Collision();
  timer++;
  if (timer>=5)                                    ///// Animationsschritte
  {                                                   //
   timer=0;                                           //
   anim++;                                            //
   if (anim==29)                                      //
    anim=27;                                          //
  }                                                /////
  if (!dir)
   x-=2+timer/4;                                   ///// X-Verschiebung
  else                                                //
   x+=2+timer/4;                                      //
						      //
  if (x>320*3)                                        //
  {                                                   //
   x-=320*3;                                          //
   y--;                                               //
  }                                                   //
  else                                                //
  if (x<0)                                            //
   x+=320*3;                                       /////

  if (VGetPixel((x/3)+18-dir*12,y+19)>=250)
   y--;
  if (VGetPixel((x/3)+18-dir*12,y+20)<250)         ///// Boden unter Fen?
  {                                                   //
   fall++;                                            // Fallbeschl.
   if (fall<15)                                       // nhern
    y++;                                              //
   else                                               //
    y+=2;                                             //
  }                                                   //
  else fall=0;                                        //
						   /////

  if (x<=22*3 && y>165)                             ///// Tube
  {                                                    //
   stimer=70;                                          //
   x=8*3; y=3; dir=1;                                  //
  }                                                    //
  if (x>=288*3 && y>165)                               //
  {                                                    //
   stimer=70;                                          //
   x=280*3; y=3; dir=0;                                //
  }                                                 /////
 }
 else
 /*************************** Tropfen platzt ***************************/
 if (status==0)
 {
  timer++;

  x+=kpos/4;                                          // X-Verschiebung
  if (x<0)
   x+=320*3;
  y-=(jump_power-timer)>>3;                           // Y-Verschiebung

  anim=dsprites[timer>>2];

  if (timer>20)                                    ///// Auflsen
  {                                                   //
   if (myrand()&1)                                    //
   {                                                  //
    status=0;                                         //
    //lifetime=0;                                     //
    identity=5;                                       //
    x=3*3; y=3; dir=1;                                //
    stimer=myrandom(600)+250;                         //
    timer=0; fall=0;                                  //
    anim=27;                                          //
   }                                                  //
   else                                               //
   {                                                  //
    status=0;                                         //
    identity=5;                                       //
    x=3*280; y=3; dir=0;                              //
    stimer=myrandom(600)+250;                         //
    timer=0; fall=0;                                  //
    anim=27;                                          //
   }                                                  //
   return;                                            //
  }                                                 ////
 }
 else
 /*************************** Tropfen attakiert *******************/

 if (status==5)                                    ///// Biest beit zu
 {                                                    //
  timer++;                                            //
  if (timer==25)                                      //
  {                                                   //
   status=1;                                          //
   Turn();                                            //
  }                                                   //
 }

}

void CDrop::Kicked(int pos)
{
 kpos=pos;
 status=0;
 timer=0;
 anim=28;
 jump_power=23;
}

void CDrop::Collision()
{
 CObject *trace;
 int rx,ry,tx,ty;

 tx=x/3;
 ty=y;

 trace=first;
 while (trace)
 {
  if (trace!=this && trace->status>0 &&        //not this one and not dead?
      !stimer && !trace->stimer)
  {
   trace->GetPos(&rx,&ry);                     //Pos. abfragen

   if (tx>=rx-18 && tx<=rx+18 && abs(ry-ty)<6) //Ineinander-Kollision
   {
    if (trace->identity==0)                    //Kollision m. Mario/Luigi?
    {
     trace->Kill(-speed,2);
     Turn();
    }
   }

   if (rx+18>=tx && rx+16<=tx)  //Kollision links
   {
    if (trace->identity==0 && abs(ry-ty)<6)     //mit Mario
    {
     trace->Kill(-speed,2);
     Turn();
    }
    else
    if (abs(ry-ty)<12 && dir==0)               // mit (langsamen) Vieh
     Turn();
   }
   else
   if (tx+18>=rx && tx+16<=rx) //Kollision rechts
   {
    if (trace->identity==0 && abs(ry-ty)<6)
    {
     trace->Kill(-speed,2);
     Turn();
    }
    else
    if (dir==1 && abs(ry-ty)<12)
     Turn();
   }
  }
  trace=trace->next;
 }
}

void inline CDrop::Destroy()
{
 if (first==this)                                  //
 {                                                 //
  first=first->next;                               //
  first->prev=NULL;                                //
 }                                                 //
						   //
 if (prev)                                         //
  prev->next=next;                                 //
 if (next)                                         //
  next->prev=prev;                                 //
}