/**************************+ CPLAYER.CPP +*******************************/

#include <conio.h>
#include <dos.h>
#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>
#include "midi.h"
#include "modex.h"
#include "keyboard.h"
#include "csound.h"

#include "classes.h"

Statusbar extern Status;

int extern sb;

extern unsigned char far *sprites;
extern unsigned char far *msprites;

CPow extern *Pow_Button;

CObject extern *first,*last;
word extern STORMTIME;

byte const dmsprites[]={55,76,77,56,78,79,57,80,81};

CPlayer::~CPlayer()
{
}

CPlayer::CPlayer(unsigned pnr,unsigned *keys)
{
 nr=pnr;
 stimer=stormtimer=identity=speed=0;
 keyb=keys;
 x=80*8+200*8*nr; y=20; dir=1; anim=0;
 status=1; timer=0; fall=0; jump_power=0;
 kicked=0;

 if (nr==0)
  color=128;
 else
  color=129;
}

void inline CPlayer::Kick(int kx, int ky, CPlayer *who)
{
 int rx=x>>3;
 if (kx>=rx-20 && kx<=rx+20 && ky>y+21 && ky<y+29)
  Kicked((rx+rx-kx-kx)/3);
}

void inline CPlayer::Draw(int page)
{
 if (y>-19)
 if (!dir)
 {
  putmcsprite(x>>3,y,page,color,sprites+514*anim);
 }
 else
 {
  putmcsprite(x>>3,y,page,color,msprites+514*anim);
 }
}

void CPlayer::Move()
{
 CObject *trace;
 byte a,b;
					     /////
 if (status)
 {
  Collision();
 }

 if (status==1)
 {
 if (*keyb & 4)                                   ///// Laufen nach links
 {                                                   //
  if (abs(speed)<4)                                  //
   speed-=2;                                         //
  else                                               //
  if (abs(speed)<17)                                 //
   speed--;                                          //
						     //
  if (speed<0)                                       //
   dir=0;                                            //
  else                                               //
   dir=1;                                            //
						     //
   timer++;                                          //
   if (timer>3)                                      //
   {                                                 //
    timer=0;                                         //
    if (!fall)                                       //
    {                                                //
     anim++;                                         //
     if (anim&1)
      PlaySound(1);                                  //
     if (anim>=7)                                    //
      anim=1;                                        //
    }                                                //
   }                                                 //
 }                                                /////
 else
 if (*keyb & 8)                                   ///// Laufen rechts
 {                                                   //
  if (abs(speed)<4)                                  //
   speed+=2;                                         //
  else                                               //
  if (abs(speed)<17)                                 //
   speed++;                                          //
						     //
  if (speed<0)                                       //
   dir=0;                                            //
  else                                               //
   dir=1;                                            //
						     //
   timer++;                                          //
   if (timer>3)                                      //
   {                                                 //
    timer=0;                                         //
    if (!fall)                                       //
    {                                                //
     anim++;                                         //
     if (anim&1)                                     //
      PlaySound(1);                                  //
						     //
      if (anim>=7)                                   //
      {                                              //
       anim=1;                                       //
      }                                              //
     }                                               //
   }                                                 //
 }                                                /////

 if ((*keyb & 16) && !fall)
 {
  jump_power=35;
  status=2;
  timer=3;
  g=1;
  kicked=0;
  PlaySound(2);

 }

 if (*keyb == 0)
 {                                                ///// Stehen /rutschen
						     //
  {                                                  //
   if (speed)                                        //
   {                                                 //
    if (speed>0)                                     //
     speed--;                                        //
    else                                             //
     speed++;                                        //
						     //
    timer++;                                         //
    if (timer>=2)                                    //
     timer=0;                                        //
    anim=8+(timer&1);                                //
   }                                                 //
   else                                              //
    anim=0;                                          //
  }                                                  //
 }                                                /////

 stormtimer++;
 if (stormtimer>=STORMTIME)
 {
  CObject *buffer;
  if (myrand()&1)
   buffer=new CStorm(3,y-4,1);
  else
   buffer=new CStorm(320-24-7,y-4,0);

  last->next=buffer;
  buffer->prev=last;
  last=buffer;
  buffer->next=NULL;
  stormtimer=0;
 }

 x+=(speed+speed+speed)>>2;          //== *3/4    ///// X-POS Verschiebung
 if (x<0)                                            //
  x=320*8-x;                                         // und Rand
 else                                                // berprfen
  if(x>320*8)                                        //
  {                                                  //
   x-=320*8;                                         //
   y--;                                              //
  }                                               /////

 if (VGetPixel((x>>3)+12,y+19)>=250)             ///// Boden unter Fen?
  y--;

 if (VGetPixel((x>>3)+12,y+20)<=250)             ///// Boden unter Fen?
 {                                                   //
  fall++;                                            // Fallbeschl.
  if (fall<15)                                       // nhern
   y++;                                              //
  else                                               //
  {                                                  //
   stormtimer=0;                                     //
   y+=2;                                             //
  }                                                  //
 }                                                   //
 else fall=0;                                        //
 }                                                /////
 else
 if (status==2)   //jump
 {
  x+=(speed+speed)>>2;                //== *2/4    ///// X-POS Verschiebung
  if (x<0)                                            //
   x=320*8-x;                                         // und Rand
  else                                                // berprfen
   if(x>320*8)                                        //
   {                                                  //
    x-=320*8;                                         //
    y--;                                              //
   }                                               /////

  a=VGetPixel((x>>3)+6,y); b=VGetPixel((x>>3)+18,y);
  if ((char)a>2 || a>249 || (char)b>2 || b>249)
  {
   //////////////////////////////////////////////////////////////////Kick
   if (!kicked)                              ///// nur bei 1. Aufschlag
   {                                            // berprfung auf
    kicked=1;                                   // Treffer!
    PlaySound(3);                               //
    trace=first;                                //
    while(trace)                                //
    {                                           //
     trace->Kick(x>>3,y,this);                  //
     trace=trace->next;                         //
    }                                        /////
    Pow_Button->Kick(x>>3,y,NULL);              // POW-Button gesondert pr.
   }
   y+=(jump_power-timer)>>3;
   g=2;
  }

  y-=(jump_power-timer)>>3;
  timer+=g;
  anim=7;
  if (((int)jump_power-(int)timer)<=0)
  {
   status=1;
   fall=1;
   timer=0;
   anim=7;
  }
 }
 else
 /********************** Toter Mario strzt ab ***************************/
 if (status==0)
 {
  timer++;
  if (timer%6==0)                                  ///// Animationsschritte
  {                                                   //
   aindex++;                                          //
   if (aindex==2)                                     //
    aindex=0;                                         //
  }                                                /////
  anim=dmsprites[deathtype*3+(aindex+1)];

   y+=timer>>3;                                       // Y-Verschiebung
   if (y>200)
   {                                             ////  Falls noch Leben->
    if (Status.lives[nr])                          //    oben beginnen
    {                                              //
     Status.lives[nr]--;                           //
     Status.UpdateLives(nr);                       //
     status = 3;                                   //
     x=(136+26*nr)<<3;                             //
     y=10;                                         //
     anim=0;                                       //
     dir=1;					   //
     stimer=700;                                 ////
    }
    else					   ///// Objekt entfernen
    {                                                  //
     Destroy();                                        //
     delete this;                                      //
     return;                                           //
    }                                                  //
   }                                               /////
 }
 else
 if (status==3)                                    ///// Mario wartet oben
 {                                                    //
  stimer--;                                           //
  if (!stimer)                                        //
   status=1;                                          //
  else                                                //
  if (stimer<(700-280) && *keyb)                      //
  {                                                   //
   speed=0;                                           //
   stimer=0;                                          //
   status=1;                                          //
  }                                                   //
 }                                                    //
}                                                   ////

void inline CPlayer::Destroy()
{
 if (first==this)                                  //
 {                                                 //
  first=first->next;                               //
  first->prev=NULL;                                //
 }                                                 //
						   //
 if (last==this)                                   //
 {                                                 //
  last=prev;                                       //
 }                                                 //
						   //
 if (prev)                                         //
  prev->next=next;                                 //
 if (next)                                         //
  next->prev=prev;                                 //
}

void CPlayer::Kicked(int pos)
{
 status=2;
 timer=0;
 if (pos>0)
  dir=1;
 else
  dir=0;
 speed=pos;
 jump_power=23;
}


void CPlayer::Collision()
{
 int rx,ry,tx,ty;
 CObject *trace;

 tx=x>>3;
 ty=y;

 trace=first;
 while (trace)
 {
  if (trace!=this)                             //not this one?
  {
   trace->GetPos(&rx,&ry);                     //Pos. abfragen
   if (tx>=rx-20 && tx<=rx+20 && abs(ry-ty)<5)
   {
    if (trace->identity && trace->identity!=6)
    {
     if (trace->status==2 && !trace->stimer)
     {
      Status.score[nr]+=trace->score;
      Status.UpdateScore(nr);
      trace->Kill(-speed);
     }
    }
    else
    if (trace->identity==0)
    {
     if (tx>rx)
     {
      trace->x-=abs(speed);
      if (trace->x<0)
       trace->x+=320*8;
     }
     else
      trace->x+=abs(speed);
    }
   }
  }
  trace=trace->next;
 }
}

void CPlayer::Kill(int pos,int type)
{
 status=0;
 timer=4;
 if (pos<0)
  dir=1;
 else
  dir=0;

 PlaySound(6);
 PlaySound(5);
 anim=dmsprites[type*3];
 aindex=0;
 deathtype=type;
}
