#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include "midi.h"

int sb;                                //SB vorhanden? (1 -> ja)
int channels[10];                      //Verwendung d. Kanle, 0 ... unused
unsigned int timers[10];               //Timer fr Kanal
int timer2[10];

void interrupt (*oldthandler)(...);
static void interrupt mythandler(...);  //Behandlung d. Sound.Int.
void MakeSound(int ch);

/*   Sound Types:     1 ... laufen
		      2 ... springen
		      3 ... mit Kopf anstoen
		      4 ... Tier strzt ab
		      5 ... Player strzt ab
		      6 ... Stot mit Tier zusammen
		      7 ... Tier kommt von oben

*/

	 //      a     d     s     r    s   v   e   s   f   w   p   a f
TON s_run     ={ 0,14, 9, 9, 6, 6, 8, 8,1,1,0,0,0,0,0,0,2,2,0,0,1,1,1,0};
TON s_jump    ={ 9, 9, 3, 3, 6, 6, 8, 8,1,1,0,0,0,0,0,0,2,2,0,0,1,1,1,0};
TON s_bounce  ={14,14,10,10,13,13,14,14,1,1,63,63,0,0,0,0,0,0,0,0,1,1,0,6};
TON s_falldown={13,13, 2, 2, 4, 4, 4, 4,0,0,0,0,0,0,0,0,1,1,0,0,0,0,1,0};
TON s_crash   ={ 4, 4, 4, 4, 2, 2, 2, 2,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0};
TON s_tube    ={ 5, 5, 5, 5, 2, 2,12,12,1,1,8,8,0,0,0,0,0,0,0,0,0,0,1,0};


void CreateCSound()
{
 int i;

 sb=detectadlib();

 for (i=0; i<10; i++)
 {
  timers[i]=0;
  channels[i]=0;
 }

 if (sb)
 {
  asm cli;
  oldthandler=getvect(0x1c);
  setvect (0x1c,mythandler);
  asm sti;
 }
}

void DestroyCSound()
{
 detectadlib();
 if (sb)
 {
  setvect(0x1c,oldthandler);
 }
}

void interrupt mythandler(...)
{
 int i;

 if (sb)
 {
  for (i=0; i<9; i++)
  {
   if (channels[i])
    MakeSound(i);
  }
 }
}

void ResetSound()
{
 detectadlib();
}

void MakeSound(int ch)
{
 switch (channels[ch])
 {
  case 0: break;

  case 1:  setf(800+timers[ch]*50,1+ch);
	   if (timers[ch]==2)
	   {
	     sbnosound(ch+1);
	     channels[ch]=0;
	   }
	   timers[ch]++;
	   break;

  case 2:
	   setf(540+timers[ch]*(30-(timers[ch]>>1)),1+ch);
	   if (timers[ch]==14)
	   {
	     sbnosound(ch+1);
	     channels[ch]=0;
	   }
	   timers[ch]++;
	   break;

  case 3:  setf(330-timers[ch]*20,1+ch);
	   if (timers[ch]==2)
	   {
	     sbnosound(ch+1);
	     channels[ch]=0;
	   }
	   timers[ch]++;
	   break;
  case 4:
  case 5:
	   {
	    timer2[ch]=timer2[ch]*8/9;
	    setf(timer2[ch],1+ch);
	    if (timer2[ch]<200)
	    {
	     sbnosound(ch+1);
	     channels[ch]=0;
	    }
	   }
	   timers[ch]++;
	   break;

  case 6:  setf(60-timers[ch]*7,1+ch);
	   if (timers[ch]==7)
	   {
	     sbnosound(ch+1);
	     channels[ch]=0;
	   }
	   timers[ch]++;
	   break;

  case 7:  setf(230-timers[ch]*10,1+ch);
	   if (timers[ch]==2)
	   {
	     sbnosound(ch+1);
	     channels[ch]=0;
	   }
	   timers[ch]++;
	   break;

 }
}

void PlaySound(int type)
{
 int i;

 if (sb && type && type!=3)
 {                         //Anstoen lst Sprung-Sound auf!!

  for (i=0; i<9; i++)
  {
   if (!channels[i])
   {
    channels[i]=type;
    timers[i]=0;
    switch (type)
    {
     case 0: break;
     case 1: setup(1+i,&s_run);
	     sbnosound(1+i);
	     setf(800,1+i);
	     break;
     case 2: setup(1+i,&s_jump);
	     sbnosound(1+i);
	     setf(540,1+i);
	     break;

     case 3: setup(1+i,&s_bounce);
	     sbnosound(1+i);
	     setf(330,1+i);
	     break;

     case 4: setup(1+i,&s_falldown);
	     sbnosound(1+i);
	     setf(1000,1+i);
	     timer2[i]=1000;
	     break;

     case 5: setup(1+i,&s_falldown);
	     sbnosound(1+i);
	     setf(1800,1+i);
	     timer2[i]=1800;
	     break;
     case 6: setup(1+i,&s_crash);
	     sbnosound(1+i);
	     setf(60,1+i);
	     break;
     case 7: setup(1+i,&s_tube);
	     sbnosound(1+i);
	     setf(230,1+i);
	     break;
    }
    break;
   }
  }
 }
 else
  if (sb && type==3)
  {
   for (i=0; i<9; i++)
   {
    if (channels[i]==2)
    {
     channels[i]=3;
     timers[i]=0;

     setup(1+i,&s_bounce);
     sbnosound(1+i);
     setf(330,1+i);
     break;
    }
   }
  }
}
