#include <dos.h>
#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>
#include "midi.h"
#include "modex.h"

#include "classes.h"

int sinval[361];

extern unsigned char far *sprites;
extern unsigned char far *msprites;
CObject extern *first, *last;

const byte stsprites[]={10,90,89,90};
const byte devsprites[]={82,85,86,87,88};

CStorm::CStorm(int nx, int ny,int nd)
{
 score=0;
 status=0;
 //lifetime=0;
 identity=6;
 x=nx*3; y=y0=ny; dir=nd;
 timer=70;
 atimer=0;
 anim=82;
}

void CStorm::Draw(int page)
{
 {
  if (!dir)
  {
   putxsprite(x/3,y,page,sprites+514*anim);
  }
  else
  {
   putxsprite(x/3,y,page,msprites+514*anim);
  }
 }
}

void CStorm::Move()
{
 /****************************** Sturm bewegt sich *********************/
 if (status==1)
 {
  timer++;
  if (timer>=6)                                    ///// Animationsschritte
  {                                                   //
   timer=0;                                           //
   atimer++;                                          //
   if (atimer==4)                                     //
    atimer=0;                                         //
   anim=stsprites[atimer];                            //
  }                                                /////
  if (!dir)
   x-=(3+timer)>>1;                                ///// X-Verschiebung
  else                                                //
   x+=(3+timer)>>1;                                   //
						    ////

  y=y0+(sinval[(x)&360])/20;                         /// Y-Bewegung



  if (x<=2*3 || x>(318-24)*3)                       ///// End
  {                                                    //
   Destroy();                                          //
   delete this;                                        //
   return;                                             //
  }                                                    //
  if (x>=288*3 && y>165)                               //
  {                                                    //
   stimer=70;                                          //
   x=280*3; y=3; dir=0;                                //
  }                                                 /////
  Collision();
  if (rval)
  {
   Destroy();
   delete this;
   return;
  }
 }
 else
 /********* 1. Entstehungsphase "noch tot"  *************************/
 if (status==0)
 {
  timer--;
  if (!timer)
  {
   timer=14;
   status=7;
  }
  anim=83+((timer>>3)&1);
 }
 else
 /************************ Sturm entwickelt sich langsam *****************/
 if (status==7)
 {
  timer--;
  if (!timer)
   status=1;
  anim=devsprites[4-(timer/3)];
 }
}

void inline CStorm::Kicked(int pos)
{
 //asm nop;    //HEHE!
}

void inline CStorm::Collision()
{
 CObject *trace;
 int rx,ry,tx,ty;

 tx=x/3;
 ty=y;

 trace=first;
 while (trace)
 {
  if (trace->identity == 0 && trace->status>0)
  {
   trace->GetPos(&rx,&ry);                     //Pos. abfragen

   if (tx>=rx-10 && tx<=rx+10 && abs(ry-ty)<12) //Ineinander-Kollision
   {
    {
     trace->Kill(0,1);
     rval=1;
    }
   }
  }
  trace=trace->next;
 }
 rval=0;
}

void inline CStorm::Destroy()
{
 if (first==this)                                  //
 {                                                 //
  first=first->next;                               //
  first->prev=NULL;                                //
 }                                                 //

 if (last==this)                                   //
 {                                                 //
  last=prev;                                       //
  last->next=NULL;                                 //
 }                 				   //
						   //
 if (prev)                                         //
  prev->next=next;                                 //
 if (next)                                         //
  next->prev=prev;                                 //
}