#include <dos.h>
#include <stdlib.h>
#include <stdio.h>
#include <alloc.h>

#define CRTC 0x3d4
#define TS 0x3c4
#define GDC 0x3ce
#define DAC 0x3c6

typedef unsigned char byte;
typedef unsigned int  word;

typedef struct {byte kenn,ver,rle,bpp;
		word xlo,ylo,xru,yru,xdpi,ydpi;
		byte pal16[48];
		byte r,planes;
		word bpb,palette;
		byte reserved[58];} PCX;



byte getkeyb()
{
 unsigned char c;

 asm{XOR AX,AX
     INT 0x16
     MOV c,AL};
 return c;
}
void setmodex ()
{
 asm{MOV AX,0x13
     INT 0x10};
 outportb(TS,4);
 outportb(TS+1,(inportb(TS+1)&247)|4);
 outportb(CRTC,0x14);
 outportb(CRTC+1,inportb(CRTC+1)&191);
 outportb(CRTC,0x17);
 outportb(CRTC+1,inportb(CRTC+1)|64);
 outportb(TS,0x02);
 outportb(TS+1,inportb(TS+1)|15);

 asm{MOV AX,0xa000
     MOV ES,AX
     XOR DI,DI
     CLD
     MOV CX,32000
     MOV AX,0x0000
     REP STOSW}
}

void settext()
{
 asm{MOV AX,0x0003
     INT 0x10}
}

void use400()
{
 outportb(CRTC,9);
 outportb(CRTC+1,inportb(CRTC+1)&112);
}

void putpixel (int x, int y, unsigned char col, int page)
{
 asm{MOV AX,0xa000
     MOV ES,AX
     MOV AX,0x3e80
     MOV BX,page
     MUL BX
     MOV DI,AX
     MOV CX,3
     AND CX,x
     MOV BX,1
     SHL BX,CL
     MOV DX,TS
     MOV AL,0x02
     MOV AH,BL
     OUT DX,AX
     MOV AX,y
     MOV BX,AX
     SHL AX,6
     SHL BX,4
     ADD AX,BX
     ADD DI,AX
     MOV AX,x
     SHR AX,1
     SHR AX,1
     ADD DI,AX
     MOV AL,col
     MOV ES:[DI],AL}
}
void fastpp (int x, int y, byte col, word scrof)
{
 asm{MOV DI,0xa000
     MOV ES,DI
     MOV DI,scrof
     MOV CL,3
     AND CX,x
     MOV BX,1
     SHL BX,CL
     MOV DX,TS
     MOV AL,0x02
     MOV AH,BL
     OUT DX,AX
     MOV AX,y
     MOV BX,AX
     SHL AX,6
     SHL BX,4
     ADD AX,BX
     ADD DI,AX
     MOV AX,x
     SHR AX,1
     SHR AX,1
     ADD DI,AX
     MOV AL,col
     MOV ES:[DI],AL}
}

byte getpixel (int x, int y, int page)
{
 byte c;
 asm{MOV AX,0xa000
     MOV ES,AX
     MOV AX,16000
     MOV BX,page
     MUL BX
     MOV DI,AX
     MOV CX,3
     AND CX,x
     MOV DX,GDC
     MOV AL,0x04
     MOV AH,CL
     OUT DX,AX
     MOV AX,y
     MOV BX,AX
     SHL AX,6
     SHL BX,4
     ADD AX,BX
     ADD DI,AX
     MOV AX,x
     SHR AX,1
     SHR AX,1
     ADD DI,AX
     MOV AL,ES:[DI]
     MOV c,AL};
 return c;
}

void setlstart(word start)
{
 byte high,low;

 high=start>>8;
 low=start&255;
 outportb(CRTC,0x0c);
 outportb(CRTC+1,high);
 outportb(CRTC,0x0d);
 outportb(CRTC+1,low);
}


void rgb(int x,char r,char g,char b)
{
 outportb(0x3c8,x);
 outportb(0x3c9,r);
 outportb(0x3c9,g);
 outportb(0x3c9,b);
}

void dark(int tim)
{
 int j;
 unsigned char i,r,g,b;

 for (i=0;i<65; i++)
 {
  for (j=0;j<=255; j++)
  {
   outportb(0x03c7,j);
   r=inportb(0x03c9);
   g=inportb(0x03c9);
   b=inportb(0x03c9);
   outportb(0x03c8,j);
   if (r>0) outportb(0x03c9,r-1);
    else outportb(0x3c9,r);
   if (g>0) outportb(0x03c9,g-1);
    else outportb(0x3c9,g);
   if (b>0) outportb(0x03c9,b-1);
    else outport(0x3c9,b);
  }
  delay(tim);
 }
}


void raster()
{
asm mov dx,0x03DA
l1:
asm{in al,dx
    and al,0x08
    jnz l1}
l2:
asm{in al,dx
    and al,0x08
    jz l2}
}

byte far* getxsprite (word x, word y, word xl, word yl, char page)
{
 byte far *z;
 word xn,s,o,l,scrof;
 byte zl,plane;

 if ((xl&3)!=0)
  xn=xl+(4-(xl&3));
 else
  xn=xl;

 z=farmalloc(xn*yl+5);
 if (z != NULL)
 {
  zl=4;
  *(z+0)=xl>>7;
  *(z+1)=xl%255;
  *(z+2)=yl>>7;
  *(z+3)=yl%255;

  o=FP_OFF(z);
  s=FP_SEG(z);

 asm{PUSH DS
     MOV AX,0xa000
     MOV DS,AX
     MOV AX,16000
     MOV BL,page
     XOR BH,BH
     MUL BX
     MOV SI,AX

     MOV AX,s
     MOV ES,AX
     MOV DI,o
     ADD DI,4       //damit mit 4 Byte info OK!
     MOV AX,xl
     SHR AX,1
     SHR AX,1
     MOV l,AX

     MOV AX,y
     MOV BX,AX
     SHL AX,6
     SHL BX,4
     ADD AX,BX
     ADD SI,AX
     MOV AX,x
     SHR AX,1
     SHR AX,1
     ADD SI,AX

     MOV scrof,SI

     MOV CL,3
     AND CX,x
     MOV DX,GDC
     MOV AL,4
     MOV AH,CL
     MOV plane,AH
     OUT DX,AX
     CLD}
 hlp:
 asm{MOV BX,yl}
 l2:
 asm{MOV CX,l
     REP MOVSB
     ADD SI,80
     SUB SI,l
     DEC BX
     JNZ l2

     MOV AH,plane
     INC AH
     CMP AH,4 //!!
     JNZ jp3
     XOR AH,AH
     INC scrof}
 jp3:
 asm{MOV SI,scrof
     MOV plane,AH
     DEC byte ptr zl
     JZ ende
     MOV DX,GDC
     MOV AL,0x04
     OUT DX,AX
     JMP hlp}
 ende:
 asm{POP DS};
 }
 return z;
}

void putxsprite (word x, word y, byte page, byte far *data)
{
 word s,o,l,xl,yl,scrof;
 byte plane,zl;
 xl=(*(data+0)<<8)+*(data+1);
 yl=(*(data+2)<<8)+*(data+3);
 zl=4;

 s=FP_SEG(data);
 o=FP_OFF(data);

 asm{PUSH DS

     MOV AX,0xa000
     MOV ES,AX
     MOV AX,16000
     MOV BL,page
     XOR BH,BH
     MUL BX
     MOV DI,AX

     MOV AX,s
     MOV DS,AX
     MOV SI,o
     ADD SI,4       //damit mit 4 Byte info OK!
     MOV AX,xl
     SHR AX,1
     SHR AX,1
     MOV l,AX

     MOV AX,y
     MOV BX,AX
     SHL AX,6
     SHL BX,4
     ADD AX,BX
     ADD DI,AX   //*
     MOV AX,x
     SHR AX,1
     SHR AX,1
     ADD DI,AX

     MOV scrof,DI

     MOV CL,3
     AND CX,x
     MOV AX,1
     SHL AX,CL
     MOV AH,AL
     MOV DX,TS
     MOV AL,0x02
     MOV plane,AH
     OUT DX,AX
     CLD}
 hlp:
 asm{MOV BX,yl}
 l2:
 asm{MOV CX,l}
 l1:
 asm{MOV AL,DS:[SI]
     OR AL,AL
     JZ jp1
     MOV ES:[DI],AL};
 jp1:
 asm{INC DI
     INC SI
     DEC CX
     JNZ l1
     ADD DI,80
     SUB DI,l
     DEC BX
     JNZ l2

     MOV DI,scrof
     MOV AH,plane
     SHL AH,1
     CMP AH,16
     JNZ jp3
     MOV AH,1
     INC DI
     INC scrof}
 jp3:
 asm{MOV plane,AH
     DEC byte ptr zl
     JZ ende
     MOV DX,TS
     MOV AL,0x02
     OUT DX,AX
     JMP hlp}
 ende:
 asm{POP DS};
}

void clear (char page)
{
 asm{MOV AX,0xa000
     MOV ES,AX
     MOV BL,page
     XOR BH,BH
     MOV AX,16000
     MUL BX
     MOV DI,AX
     MOV DX,TS
     MOV AL,2
     OUT DX,AL
     INC DX
     IN AL,DX
     OR AL,0x0f
     OUT DX,AL
     CLD
     MOV CX,8000
     MOV AX,0x0000
     REP STOSW}
}

byte far* loadchar(unsigned char *name)
{
 byte far *a;
 int i;
 unsigned char c;
 FILE *x;

 a=farmalloc(0x1002);
 if (a!=NULL)
 {
  x=fopen(name,"rb");
  c=getc(x);
  c=getc(x);
  for (i=0; i<=0x1000; i++)
  {
   c=getc(x);
   *(a+i)=c;
  }
  fclose(x);
 }
 return a;
}

int len(char *string)
{
 int i=0;
 while (*(string+i)!=0)
  i++;
 return i;
}

void print (int x,int y, unsigned char col, char page, char *string,
	    byte revers, byte far *character)
{
 int lengh,Lengh;
 byte c,d,rev;
 byte shape[320*8+3];
 register int i,j,p;
 word scrof;

 lengh=len(string);
 Lengh=lengh*8;
 scrof=page*16000;
 if (revers!=0)
  rev=128;
 else
  rev=0;

 for (i=0; i<=320*8+2; i++)
  shape[i]=0;
 shape [0]=lengh;
 shape [1]=8;
 p=0;
 while (*(string+p)!=0)
 //for (p=0; p<=lengh; p++)
 {
  c=*(string+p);
  if (c>=64 && c<=90) c-=64;
  else
   if (c>=32 && c<=63) asm NOP;
   else
    if (c==0x5b) c=27;
    else
     if (c==0x5d) c=29;
     else
      if (c>=96 && c<=0x7a) c-=32;
      else
       if (c>=128 && c<=254) c-=32;
       else c=32;
w:
  c+=rev;
  for (i=0; i<=7; i++)       // bertragen in Shape
  {
   d=*(character+c*8+i);
   if ((d&128)==128) shape [2+p*8+i*Lengh]=col;
   if ((d&64)==64) shape [2+1+p*8+i*Lengh]=col;
   if ((d&32)==32) shape [2+2+p*8+i*Lengh]=col;
   if ((d&16)==16) shape [2+3+p*8+i*Lengh]=col;
   if ((d&8)==8) shape [2+4+p*8+i*Lengh]=col;
   if ((d&4)==4) shape [2+5+p*8+i*Lengh]=col;
   if ((d&2)==2) shape [2+6+p*8+i*Lengh]=col;
   if ((d&1)==1) shape [2+7+p*8+i*Lengh]=col;
  }
  p++;
 }
 for (i=0; i<=7; i++)
  for (j=0; j<Lengh; j++)
   if (shape[i*Lengh+j+2]!=0)
    fastpp (j+x,i+y,col,scrof);
}

char MYpeek (unsigned int s, unsigned int o)
{
 char b;
 asm{CLI
     MOV AX,s
     MOV ES,AX
     MOV BX,o
     MOV DI,BX
     MOV AL,[ES:DI]
     MOV b,AL
     STI};
 return b;
}

void MYpoke (unsigned int s, unsigned int o, char value)
{
 asm{CLI
     MOV AX,s
     MOV ES,AX
     MOV BX,o
     MOV DI,BX
     MOV AL,value
     MOV [ES:DI],AL
     STI}
}


int loadpcx(word x, word y,char *filename, PCX *header, char page)
{
 FILE *fl;
 PCX a;
 word j,xx,yy,scrof,px,py;
 long i;
 byte ch,ci,r,g,b,col;

 scrof=page*16000;
 fl=fopen(filename,"rb");
 fread (&a,1,128,fl);
/*
 printf("Kennung: %X\n",a.kenn);
 printf("RLE: %u\n",a.rle);
 printf("Bits/Pixel: %u\n",a.bpp);
 printf("Koordinaten links oben: %u,%u\n",a.xlo,a.ylo);
 printf("Koordinaten rechts unten: %u,%u\n",a.xru,a.yru);
 printf("hoizontale Aufl.: %u\n",a.xdpi);
 printf("vertikale Aufl.: %u\n",a.ydpi);
 printf("Palette 16Color.: ...\n");
 printf("reserviertes Byte: %u\n",a.r);
 printf("Anzahl d. Planes: %u\n",a.planes);
 printf("Bytes/Bildzeile: %u\n",a.bpb);
 printf("Art d. Palette: %u\n",a.palette);
 printf("Reserviert: ...\n");
 */
 xx=x; yy=y;
 i=0;
 do
 {
  ch=getc(fl);
  if ((ch&(128+64))!=128+64)
  {
   //putpixel(xx,yy,ch,page);
   col=ch;
    asm{MOV DI,0xa000
	MOV ES,DI
	MOV DI,scrof
	MOV CL,3
	AND CX,xx
	MOV BX,1
	SHL BX,CL
	MOV DX,TS
	MOV AL,0x02
	MOV AH,BL
	OUT DX,AX
	MOV AX,yy
	MOV BX,AX
	SHL AX,6
	SHL BX,4
	ADD AX,BX
	ADD DI,AX
	MOV AX,xx
	SHR AX,1
	SHR AX,1
	ADD DI,AX
	MOV AL,col
	MOV [ES:DI],AL};

   i++;
   xx++;
   if (xx-x>=a.bpb)
   {
    xx=x;
    yy++;
   }
  }
  else
  {
   ci=getc(fl);
   for (j=1; j<=(ch&63); j++)
   {
    //putpixel(xx,yy,ci,page);
    col=ci;
    asm{MOV DI,0xa000
	MOV ES,DI
	MOV DI,scrof
	MOV CL,3
	AND CX,xx
	MOV BX,1
	SHL BX,CL
	MOV DX,TS
	MOV AL,0x02
	MOV AH,BL
	OUT DX,AX
	MOV AX,yy
	MOV BX,AX
	SHL AX,6
	SHL BX,4
	ADD AX,BX
	ADD DI,AX
	MOV AX,xx
	SHR AX,1
	SHR AX,1
	ADD DI,AX
	MOV AL,col
	MOV [ES:DI],AL}

    i++;
    xx++;
    if (xx-x>=a.bpb)
    {
     xx=x;
     yy++;
    }
   }
  }
 } while (i<(long)(a.yru-a.ylo+1)*(long)(a.xru-a.xlo+1));

 r=getc(fl);
 r=getc(fl);
 r=getc(fl);
 r=getc(fl);
 for (i=1; i<=255; i++)
  {
   r=getc(fl)/4;
   g=getc(fl)/4;
   b=getc(fl)/4;
   rgb (i,r,g,b);
  }
 fclose(fl);
 *header=a;
 return 0;
}

void getpcxinfo(char *filename, PCX *header)
{
 FILE *x;
 PCX a;
 word i,j;
 byte ch,ci,r,g,b;

 x=fopen(filename,"rb");
 fread (&a,1,128,x);
 i=0;
 do
 {
  ch=getc(x);
  if ((ch&(128+64))!=128+64)
  {
   //*(screen+i)=ch;
   i++;
  }
  else
  {
   ci=getc(x);
   for (j=1; j<=(ch&63); j++)
   {
    //*(screen+i)=ci;      // I wonder, it's frightening,
			   // doing that, is that thr right thing?
    i++;
   }
  }
 } while (i<(a.yru-a.ylo+1)*(a.xru-a.xlo+1)+4);

 for (i=1; i<=255; i++)
  {
   r=getc(x)/4;
   g=getc(x)/4;
   b=getc(x)/4;
   //rgb (i,r,g,b);        // YES!
  }
 fclose(x);
 *header=a;
}

void viewpage (char page)
{
 setlstart(16000*page);
}

void copyscreen (word quelle, word ziel)
{
 asm{MOV DX,TS
     MOV AX,0x0f02
     OUT DX,AX
     MOV DX,GDC
     MOV AX,0x4105
     OUT DX,AX

     PUSH DS
     MOV AX,0xa000
     MOV ES,AX
     MOV DS,AX
     MOV SI,quelle
     MOV DI,ziel
     MOV CX,16000
     REP MOVSB
     POP DS
     MOV DX,GDC
     MOV AX,0x4005
     OUT DX,AX}
}

void putosprite (int x, int y, char page, byte far *data)
{
 register word i,j;
 register byte col;
 word scrof,xx,yy;
 byte xl,yl;

 scrof=page*16000;
 xl=*(data+0);
 yl=*(data+1);

 for (i=0; i<yl; i++)
  for (j=0; j<xl; j++)
  {
   col=*(data+i*xl+j+2);
   if (col!=0)
    //fastpp (j+x,i+y,col,scrof);
   {
    xx=x+j;
    yy=i+y;
    asm{MOV DI,0xa000
	MOV ES,DI
	MOV DI,scrof
	MOV CL,3
	AND CX,xx
	MOV BX,1
	SHL BX,CL
	MOV DX,TS
	MOV AL,0x02
	MOV AH,BL
	OUT DX,AX
	MOV AX,yy
	MOV BX,AX
	SHL AX,6
	SHL BX,4
	ADD AX,BX
	ADD DI,AX
	MOV AX,xx
	SHR AX,1
	SHR AX,1
	ADD DI,AX
	MOV AL,col
	MOV [ES:DI],AL};
   }
  }
}

void yline (word ya, word ye, word x, byte col, char page)
{
 asm{MOV AX,0xa000
     MOV ES,AX
     MOV AX,16000
     XOR BH,BH
     MOV BL,page
     MUL BX
     MOV DI,AX
     MOV AX,x
     SHR AX,1
     SHR AX,1
     ADD DI,AX
     MOV AX,ya
     MOV BX,AX
     SHL AX,6
     SHL BX,4
     ADD AX,BX
     ADD DI,AX        //Offset berechnen

     MOV CX,3
     AND CX,x
     MOV AH,1
     SHL AH,CL
     MOV DX,TS
     MOV AL,0x02
     OUT DX,AX       //Plane whlen

     CLD
     MOV CX,ye
     SUB CX,ya
     MOV AL,col};
l1:
 asm{STOSB
     ADD DI,79
     DEC CX
     JNZ l1};
}

void xline (word xa, word xe, word y, byte col, char page)
{
 word x,scrof;
 byte c;

 scrof=page*16000;

 for (x=xa; x<=xe; x++)
  {
   c=col;
   asm{ MOV DI,0xa000
	MOV ES,DI
	MOV DI,scrof
	MOV CL,3
	AND CX,x
	MOV BX,1
	SHL BX,CL
	MOV DX,TS
	MOV AL,0x02
	MOV AH,BL
	OUT DX,AX
	MOV AX,y
	MOV BX,AX
	SHL AX,6
	SHL BX,4
	ADD AX,BX
	ADD DI,AX
	MOV AX,x
	SHR AX,1
	SHR AX,1
	ADD DI,AX
	MOV AL,c
	MOV [ES:DI],AL};
  }
}

void input(int x, int y, byte col, char page,
	   byte far *string, byte lengh, byte far *zchn)
{
 byte ch,i,c[3];
 char leer[8*8+3];
 for (x=0; x<=66; x++)
  leer[x]=255;
 rgb(255,0,0,0);
 leer[0]=8;
 leer[1]=8;
 c[1]=0;

 do
  {
   ch=getkeyb();
   if (ch>96 && ch<92+32) ch-=32;
   putosprite (x,y,page,leer);
   c[0]=ch;
   print(x,y,col,page,c,0,zchn);
   x+=8;
   print(x,y,col,page," ",1,zchn);
   *(string+i)=ch;
   i++;
  }while (ch!=13 && i<=lengh);
 *(string+i-1)=0;
 *(string+i)=13;
 putosprite (x,y,page,leer);
}

void offscreen()
{
 outportb(TS,1);
 outportb(TS+1,inportb(TS+1)|32);
}

void onscreen()
{
 outportb(TS,1);
 outportb(TS+1,inportb(TS+1)&(255-32));
}
/*
void line (int x1, int y1, int x2, int y2, byte col, int page)
{
 int x,y;
 word scrof=page*16000;

 asm{MOV SI,x1
     MOV x,SI
     SUB SI,x2
     MOV AX,y1
     MOV BX,AX
     SUB AX,y2
     MOV CX,100
     IMUL CX
     IDIV SI
     MOV SI,AX
     XOR CX,CX};
lp:
 asm PUSHA;
 fastpp(x,_BX,col,scrof);
 asm{POPA
     ADD CX,SI
     CMP CX,100
     JB kein_ueberlauf
     SUB CX,100
     INC BX};
kein_ueberlauf:
 asm{INC x
     MOV AX,x
     CMP AX,x2
     JB lp};
} */

void line(int x1, int y1, int x2, int y2, byte col, byte page)
{
 float k,step,i;
 int delta;
 word scrof=page*16000;

 if (x1==x2) yline (y1,y2,x1,col,page);
 else
  if (y1==y2) xline (x1,x2,y1,col,page);
  else
  {
   delta=abs(x2-x1);
   step=(float)delta/320.0;
   k=(float)(y2-y1)/(float)delta;
   for (i=0; i<=delta; i+=step)
    fastpp (x1+i,y1+i*k,col,scrof);
  }
}

void box (int x1, int y1, int x2, int y2, char col, char page)
{
 unsigned alx,ganze,ul,x=x1,y=y2-y1,scrof;

 ul=x2&3;
 alx=(4-(x1&3))&3;
 ganze=(x2-x1-ul-alx)>>2;
 //scrof=16000*page+y1*80+(x>>2);

 asm{MOV AX,0xa000
     MOV ES,AX
     MOV AX,16000
     MOV BL,page
     XOR BH,BH
     MUL BX
     MOV CX,AX
     MOV AX,80
     MOV BX,y1
     MUL BX
     MOV BX,x
     SHR BX,2
     ADD AX,BX
     ADD AX,CX
     MOV scrof,AX
     MOV DI,AX
     MOV AX,alx
     CMP AX,0
     JZ noalx
     CMP AX,1
     JNZ no1
     MOV BX,8};
 no1:
 asm{CMP AX,2
     JNZ no2
     MOV BX,12};
 no2:
 asm{CMP AX,3
     JNZ no3
     MOV BX,14};
 no3:
 asm{MOV DX,TS
     MOV AL,2
     MOV AH,BL
     OUT DX,AX
     MOV AL,col
     MOV CX,y};
 c1:
 asm{MOV ES:[DI],AL
     ADD DI,80
     LOOP c1
     INC scrof};

 noalx:
 asm{MOV CX,ganze
     CMP CX,0
     JZ noganze
     MOV DI,scrof
     MOV DX,TS
     MOV AX,0x0f02
     OUT DX,AX
     MOV AL,col
     MOV BX,y
     MOV DX,ganze};
 c3:
 asm{MOV CX,DX
     REP STOSB
     ADD DI,80
     SUB DI,DX
     DEC BX
     JNZ c3
     MOV DX,ganze
     ADD scrof,DX};
 noganze:
 asm{MOV DX,ul
     CMP DX,0
     JZ noul
     MOV DI,scrof
     CMP DX,1
     JNZ no4
     MOV BX,DX};
 no4:
 asm{CMP DX,2
     JNZ no5
     MOV BX,3};
 no5:
 asm{CMP DX,3
     JNZ no6
     MOV BX,7};
 no6:
 asm{MOV DX,TS
     MOV AL,2
     MOV AH,BL
     OUT DX,AX
     MOV CX,y
     MOV AL,col};
 lc:
 asm{STOSB
     ADD DI,79
     LOOP lc};
 noul:
 asm{NOP};
}

void scr2mem(unsigned scrof,byte far *mem, unsigned length)
{
 unsigned sg,of;

 sg=FP_SEG(mem);
 of=FP_OFF(mem);
 length=length/4;

 asm{push ds
     cld
     mov ax,sg
     mov es,ax
     mov di,of
     mov ax,0xa000
     mov ds,ax
     mov dx,GDC
     mov al,0x04
     xor bx,bx};
 lp1:
 asm{mov si,scrof
     mov ah,bl
     out dx,ax
     mov cx,length
     rep movsd
     inc bx
     cmp bx,4
     jne lp1
     pop ds};
}

void mem2scr(byte far*mem, unsigned scrof, unsigned length)
{
 unsigned sg,of;

 sg=FP_SEG(mem);
 of=FP_OFF(mem);

 length=length/4;

 asm{push ds
     cld
     mov ax,sg
     mov ds,ax
     mov si,of
     mov ax,0xa000
     mov es,ax
     xor bx,bx
     mov dx,TS};
 lp1:
 asm{mov di,scrof
     mov cx,bx
     and cx,3
     mov ax,1
     shl ax,cl
     mov ah,al
     mov al,0x02
     out dx,ax
     mov cx,length
     rep movsd
     inc bx
     cmp bx,4
     jne lp1
     pop ds};
}

